
package framework;

/**
 * Gets an instance of the dance style to implement
 * Returns the selected dance
 * @author micaramarajh
 */

public class DanceStyleFactory {
    
    public enum DanceStyleType {
        SALSA, BACHATA, CHACHACHA
    }
    
    /**
     * @param string type for name of dance style
     * @return dance style
     */
    public static DanceStyle getInstance(String a) {
        if (a.equalsIgnoreCase("salsa")) 
        {
            return new Salsa();
        }
        return null;
    }
    
    // TODO
    public static DanceStyle getInstance(DanceStyleType type)
    {
        switch (type)
        {
            case SALSA: {
                return new Salsa();
            }
            
            case BACHATA: {
                return new Bachata();
            }
            
            case CHACHACHA: {
                return null;
            }
            
            default:
            {
                return null;
            }
        }
    }
}


