package framework;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author micaramarajh
 */
public class DanceStyleYAMLGenerator {

    private String description;
    private ArrayList<Line> lineArrayList;
    
    public void printToScreen() {
        final String twoSpace = "  ";
        final String fourSpace = "    ";
        try {
        System.out.println("description: " + this.description);
        System.out.println("lineArrayList:");
        for (Line line : lineArrayList)
        {
            // add all entries of line to YAML file
            // remember to keep track of spaces
            System.out.println(fourSpace.concat("- name: ").concat(line.getName()));
            System.out.println(fourSpace.concat("lineElementArray:"));
            for (Element element : line.getLineElementArray())
            {
               System.out.println(fourSpace.concat(fourSpace).concat("- name: ").concat(element.getName())); 
               System.out.println(fourSpace.concat(fourSpace).concat(twoSpace).concat(element.getSymbol())); 
            }
        }
        } catch (Exception e) {
            
        }
    }
    
    final String twoSpace = "  ";
    final String fourSpace = "    ";
    
    public void writeYAMLFile(String fileName) {

        try {
        PrintWriter writer = new PrintWriter(new FileWriter(new File(fileName)));
        
        writer.println("description: " + this.description);
        writer.println("lineArrayList:");
        for (Line line : lineArrayList)
        {
            // add all entries of line to YAML file
            // remember to keep track of spaces
            writer.println(fourSpace.concat("- name: ").concat(line.getName()));
            writer.println(fourSpace.concat("lineElementArray:"));
            for (Element element : line.getLineElementArray())
            {
               writer.println(fourSpace.concat(fourSpace).concat("- name: ").concat(element.getName())); 
               writer.println(fourSpace.concat(fourSpace).concat(twoSpace).concat(element.getSymbol())); 
            }
        }
        
        writer.close();
        
        } catch (Exception e) {
            
        }
    }
    
    public Move parseMoveYAMLFile(String fileName)
    {
        Move move = new Move();
        try {
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(new FileInputStream("src/main/java/framework/testyaml.yml")));
        String line;
        Line newLine = new Line();
        Element newElement = new Element();
        ArrayList <Element> elemArr = new ArrayList<>();
        while ((line = bufferedReader.readLine()) != null)
        {
            if (line.contains("lineArrayList:"))
            {
                System.out.println("lineArrayList");
                continue;
            }
            
            if (line.startsWith("    - name:"))
            {
                System.out.println("Name 1");
                if (!elemArr.isEmpty())
                {
                    newLine.setLineElementArray((Element[])elemArr.toArray());
                    move.addLine(newLine);
                    newLine = new Line();
                    elemArr.clear();
                }
                
                newLine.setName(line.split(":")[1].trim());
                continue;
            }
            
            if (line.contains("lineElementArray"))
            {
                System.out.println("lineElementArray");
                newElement = new Element();
                continue;
            }
            
            if (line.contains("        - name:"))
            {
                System.out.println("Name 2");
                newElement.setName(line.split(":")[1].trim());
                continue;
            }
            
            if (line.contains("symbol"))
            {
                System.out.println("Symbol");
                newElement.setSymbol(line.split(":")[1].trim());
                elemArr.add(newElement);
                continue;
            }
        }
        
        // end case over here
        newLine.setLineElementArray((Element[])elemArr.toArray());
        move.addLine(newLine);
        } catch (Exception e)
        {
            
        }

        
        for (Line l : move.getLineArrayList())
        {
            System.out.println(l.getName());
            for (Element e: l.getLineElementArray())
            {
                System.out.println(e.getName());
                System.out.println(e.getSymbol());
            }
        }
        
        return move;
    }
    
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public ArrayList<Line> getLineArrayList() {
        return lineArrayList;
    }

    public void setLineArrayList(ArrayList<Line> lineArrayList) {
        this.lineArrayList = lineArrayList;
    }

}
