/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package framework;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.dataformat.yaml.YAMLFactory;
import com.fasterxml.jackson.dataformat.yaml.YAMLMapper;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JTextField;
import plugin.SalsaPlugin;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;
import org.apache.commons.io.FilenameUtils;
import plugin.DancePluginInterface;
import plugin.PluginLoader;

/**
 *
 * @author jordy
 */
public class MainInterface extends javax.swing.JFrame {

    ArrayList<DancePluginInterface> danceStyles;

    /**
     *
     * Creates new form MainInterface
     */
    public MainInterface() {
        initComponents();
        danceStyles = new ArrayList<>();
        addNewMoveButton.setEnabled(false);
        removeSelectedMoveButton.setEnabled(false);
        moveFileNameField.setEnabled(false);
        createMoveFileButton.setEnabled(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        danceStyleComboBox = new javax.swing.JComboBox<>();
        jLabel1 = new javax.swing.JLabel();
        addNewMoveButton = new javax.swing.JButton();
        addNewPluginButton = new javax.swing.JButton();
        openSalsationalGraphicalPipelineButton = new javax.swing.JButton();
        removeSelectedMoveButton = new javax.swing.JButton();
        movePanel = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        sequenceTable = new javax.swing.JTable();
        createMoveFileButton = new javax.swing.JButton();
        moveFileNameField = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel4.setBackground(new java.awt.Color(255, 255, 255));
        jPanel4.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        danceStyleComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                danceStyleComboBoxItemStateChanged(evt);
            }
        });
        danceStyleComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                danceStyleComboBoxActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel1.setText("Dance Styles");

        addNewMoveButton.setText("Add Move To Sequence");
        addNewMoveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addNewMoveButtonActionPerformed(evt);
            }
        });

        addNewPluginButton.setText("Add New Plugin");
        addNewPluginButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addNewPluginButtonActionPerformed(evt);
            }
        });

        openSalsationalGraphicalPipelineButton.setText("Open Salsational Graphical Pipeline");
        openSalsationalGraphicalPipelineButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openSalsationalGraphicalPipelineButtonActionPerformed(evt);
            }
        });

        removeSelectedMoveButton.setText("Remove Selected Move");
        removeSelectedMoveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeSelectedMoveButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(removeSelectedMoveButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(openSalsationalGraphicalPipelineButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(addNewMoveButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(jLabel1)
                        .addGap(59, 59, 59)
                        .addComponent(danceStyleComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 136, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(addNewPluginButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(12, 12, 12))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(danceStyleComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(addNewPluginButton, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(addNewMoveButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(removeSelectedMoveButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(openSalsationalGraphicalPipelineButton)
                .addGap(14, 14, 14))
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(41, 41, 41)
                .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        movePanel.setBackground(new java.awt.Color(255, 255, 255));
        movePanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        javax.swing.GroupLayout movePanelLayout = new javax.swing.GroupLayout(movePanel);
        movePanel.setLayout(movePanelLayout);
        movePanelLayout.setHorizontalGroup(
            movePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 513, Short.MAX_VALUE)
        );
        movePanelLayout.setVerticalGroup(
            movePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 125, Short.MAX_VALUE)
        );

        sequenceTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(sequenceTable);

        createMoveFileButton.setText("Create Move File from Sequence");
        createMoveFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createMoveFileButtonActionPerformed(evt);
            }
        });

        moveFileNameField.setText("Enter file name...");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(moveFileNameField)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(createMoveFileButton)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 137, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(createMoveFileButton)
                    .addComponent(moveFileNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(movePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addGap(0, 0, 0))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(movePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void danceStyleComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_danceStyleComboBoxItemStateChanged
        // update movePanel contents
        if (evt.getStateChange() == 1) {
            selectPlugin(danceStyleComboBox.getSelectedIndex());
            
            // update table
            
            // remove existing rows from table
            TableColumnModel model = sequenceTable.getColumnModel();
            ((DefaultTableModel) sequenceTable.getModel()).setNumRows(0);
            
            // 
            DancePluginInterface style = danceStyles.get(danceStyleComboBox.getSelectedIndex());
            
            // remove all columns from existing table
            for (int i = model.getColumnCount() - 1; i != -1; i--) {
                model.removeColumn(model.getColumn(i));
            }
            
            // add new table model
            
            for (int i = 0; i <= style.getElementsPerLine(); i++) {
                // add line column
                if (i == 0) {
                    TableColumn column = new TableColumn(i);
                    column.setHeaderValue("Line");
                    model.addColumn(column);
                } else {
                    TableColumn column = new TableColumn(i);
                    column.setHeaderValue("Element " + i);
                    model.addColumn(column);
                }
            }
        moveFileNameField.setEnabled(false);
        createMoveFileButton.setEnabled(false);
        addNewMoveButton.setEnabled(true);
        removeSelectedMoveButton.setEnabled(true);
        }
    }//GEN-LAST:event_danceStyleComboBoxItemStateChanged

    private void danceStyleComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_danceStyleComboBoxActionPerformed

    }//GEN-LAST:event_danceStyleComboBoxActionPerformed

    public void addComponentToPanel(int rows, int cols) {
        movePanel.removeAll();
        GridLayout grid = new GridLayout(rows, cols);
        movePanel.setLayout(grid);
        movePanel.setSize(movePanel.getWidth(), movePanel.getHeight());

        // rows
        for (int i = 0; i < rows; i++) {
            // cols
            for (int j = 0; j < cols; j++) {
                if (j == 0) {
                    movePanel.add(new JTextField("Hello there"));
                } else {
                    movePanel.add(new JComboBox<String>());
                }
            }
        }
    }

    public void addComponentsToPanel(int rows, int columns) {
        movePanel.removeAll();
        GridLayout gridLayout = new GridLayout(rows, columns);
        JButton b = new JButton("Just fake button");
        movePanel.setLayout(gridLayout);
        movePanel.setSize(movePanel.getWidth(), movePanel.getHeight());
        for (int row = 0; row < rows; row++) {
            for (int col = 0; col < columns; col++) {
                if (col == 0) {
                    JTextField field = new JTextField();
                    field.setEnabled(false);
                    movePanel.add(field);
                } else {
                    movePanel.add(new JComboBox<String>());
                    // add elements to combo box
                }
            }
        }

        movePanel.revalidate();
        MainInterface.this.revalidate();
    }

    private void addNewMoveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addNewMoveButtonActionPerformed

        ArrayList<String> row = new ArrayList<>();

        for (Component c : movePanel.getComponents()) {
            if (c instanceof JTextField) {
                row.add(((JTextField) c).getText());
            } else {
                row.add((String) ((JComboBox) c).getSelectedItem());
            }

            // todo change to numElements + 1
            //((DancePluginInterface)danceStyleComboBox.getSelectedItem()).
            if (row.size() == 3) {
                ((DefaultTableModel) sequenceTable.getModel()).addRow(row.toArray());
                row.clear();
            }
        }
        
        moveFileNameField.setEnabled(true);
        createMoveFileButton.setEnabled(true);

        JOptionPane.showMessageDialog(null, "Move added!");


    }//GEN-LAST:event_addNewMoveButtonActionPerformed

    /**
     * Updates the contents of UI components
     */
    public void refreshUI() {

    }

    public void refreshMovePanel() {
        movePanel.removeAll();
    }

    /**
     * Called on danceStyleComboBoxItemStateChanged, updates all combo boxes and
     * Text fields in move panel
     *
     * @param index
     */
    int count = 0;

    public void selectPlugin(int index) {
        // remove existing items from panel
        //refreshMovePanel();
        // get selected plugin
        DancePluginInterface plugin = danceStyles.get(index);
        // add text fields and combo boxes to movePanel
        int numLines = plugin.getLines().size();
        int numElements = plugin.getElementsPerLine();
        System.out.println("numLines: " + numLines);
        System.out.println("numElements: " + numElements);
        System.out.println("Calls to method: " + count++);
        addComponentsToPanel(numLines, numElements + 1);
        // add all components to panel

        // populate combo box values
        try {
            for (Element e : plugin.getElements()) {
                for (Component c : movePanel.getComponents()) {
                    if (c instanceof JComboBox) {
                        ((JComboBox) c).addItem(e.getName().concat(" ; ").concat(e.getSymbol()));
                    }
                }
            }

            // populate line names
            ArrayList<Line> lines = (ArrayList<Line>) plugin.getLines().clone();

            for (Component c : movePanel.getComponents()) {
                if (c instanceof JTextField) {
                    ((JTextField) c).setText(lines.remove(0).getName());
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void addNewPluginButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addNewPluginButtonActionPerformed
        
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Specify a plugin path...");
        try {
            // choose file
            int userSelection = fileChooser.showSaveDialog(this);
            String filePath = "";
            if (userSelection == JFileChooser.APPROVE_OPTION) {
                File fileToSave = fileChooser.getSelectedFile();

                System.out.println(fileChooser.getSelectedFile());
                filePath = fileToSave.getPath();
            }
            String fileNameWithOutExt = FilenameUtils.removeExtension(fileChooser.getSelectedFile().getName());
            DancePluginInterface h = new PluginLoader().loadDancePlugin("plugin." + fileNameWithOutExt);
            danceStyles.add(h);
            danceStyleComboBox.addItem(h.getName());
            JOptionPane.showMessageDialog(null, "Plugin added!");

        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "An error occurred while adding the plugin. Please try again.");

            e.printStackTrace();
        }
    }//GEN-LAST:event_addNewPluginButtonActionPerformed

    public Element[] arrayListToArray(ArrayList<Element> arr) {
        Element[] e = new Element[arr.size()];
        for (int i = 0; i < arr.size(); i++) {
            e[i] = arr.get(i);
        }
        return e;
    }

    public String[][] getTableData(JTable table) {
        TableModel dtm = table.getModel();
        int nRow = dtm.getRowCount(), nCol = dtm.getColumnCount();
        String[][] tableData = new String[nRow][nCol];
        for (int i = 0; i < nRow; i++) {
            for (int j = 0; j < nCol; j++) {
                tableData[i][j] = (String)dtm.getValueAt(i, j);
            }
        }
        return tableData;
    }

    private void createMoveFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createMoveFileButtonActionPerformed
        
        try {
            ObjectMapper mapper = new YAMLMapper(new YAMLFactory());
            Move move = new Move();
            String [][] vals = getTableData(sequenceTable);
            
            for (int i = 0; i < vals.length; i++) {
                Line line = new Line();
                ArrayList<Element> elements = new ArrayList<>();
                for (int j = 0; j < vals[i].length - 1; j++) {
                    if (j == 0) {
                        line.setName(vals[i][j]);
                    } else {
                        Element e = new Element();
                        String [] split = vals[i][j].split(" ; ");
                        e.setName(split[0]);
                        e.setSymbol(split[1]);
                        elements.add(e);
                    }
                }
                line.setLineElementArray(arrayListToArray(elements));
                move.addLine(line);
            }
            
            String fileName = moveFileNameField.getText();
            mapper.writeValue(new File(fileName.concat(".yml")), move);
            JOptionPane.showMessageDialog(null, "Move file created successfully!");
        } catch (IOException ex) {
            Logger.getLogger(MainInterface.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(null, "An error occurred while saving the move file. Please try again.");
        }
    }//GEN-LAST:event_createMoveFileButtonActionPerformed

    private void openSalsationalGraphicalPipelineButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openSalsationalGraphicalPipelineButtonActionPerformed
        APIUtilities.launchGraphicalInterfaceProgram();
    }//GEN-LAST:event_openSalsationalGraphicalPipelineButtonActionPerformed

    private void removeSelectedMoveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeSelectedMoveButtonActionPerformed
        // get number of lines in current dance style
        if (sequenceTable.getSelectedRow() == -1) {
            JOptionPane.showMessageDialog(null, "Select a row before attempting to delete a move.");
            return;
        }
        
        int numLines = danceStyles.get(danceStyleComboBox.getSelectedIndex()).getLines().size();
        
        if (sequenceTable.getSelectedRow() < numLines - 1) {
            DefaultTableModel dm = (DefaultTableModel) sequenceTable.getModel();
            int rowCount = dm.getRowCount();
            for (int i = rowCount - 1; i >= 0; i--) {
                dm.removeRow(i);
            }
            
            moveFileNameField.setEnabled(false);
            createMoveFileButton.setEnabled(false);
            
        } else {
            int modulus = sequenceTable.getSelectedRow() % numLines;
            int startRange = sequenceTable.getSelectedRow() - modulus;
            int endRange = startRange + numLines;
            DefaultTableModel dm = (DefaultTableModel) sequenceTable.getModel();
            for (int i = endRange - 1; i >= startRange; i--) {
                dm.removeRow(i);
            }
        }

        JOptionPane.showMessageDialog(null, "Move successfully removed!");


    }//GEN-LAST:event_removeSelectedMoveButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainInterface.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainInterface.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainInterface.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainInterface.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainInterface().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addNewMoveButton;
    private javax.swing.JButton addNewPluginButton;
    private javax.swing.JButton createMoveFileButton;
    private javax.swing.JComboBox<String> danceStyleComboBox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextField moveFileNameField;
    private javax.swing.JPanel movePanel;
    private javax.swing.JButton openSalsationalGraphicalPipelineButton;
    private javax.swing.JButton removeSelectedMoveButton;
    private javax.swing.JTable sequenceTable;
    // End of variables declaration//GEN-END:variables
}
