
package framework;

import java.util.ArrayList;
import java.util.List;

/**
 * A move object consists of a collection of lines
 * @author micaramarajh
 */

public class Move{
    
    private String description;
    private ArrayList<Line> lineArrayList;

    public Move() {
        lineArrayList = new ArrayList<Line>();
    }  

    public Move (String desc,ArrayList<Line> mArr) {
        this.description=desc;
        lineArrayList = mArr;
    }

    /************************************
     *      ACCESSORS AND MUTATORS      *
     ************************************/
    
    /**
     * 
     * @param l Add each line to create a move
     */

    public void addLine(Line l) {
        lineArrayList.add((l));
    }

    public ArrayList<Line> getLines() {
        return lineArrayList;
    }
    
    /**
     * 
     * @return array of elements to create a line
     */
    public Line getLine(int i) {
        return lineArrayList.get(i);
    }

    public void setLine(int i, Line l) {
        lineArrayList.set(i, l);
    }

    public void removeMove(int i) {
        lineArrayList.remove(i);
    }

    public void removeMove(Line l) {
        lineArrayList.remove(l);
    }
    
      public ArrayList<Line> getLineArrayList() {
        return lineArrayList;
    }

    public void setLineArrayList(ArrayList<Line> lineArrayList) {
        this.lineArrayList = lineArrayList;
    }
    
     public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Override
    public String toString() {
        return "Move{" + "description=" + description + ", lineArrayList=" + lineArrayList.toString() +'}';
    }
   
}



    
  
 
   
    
     

    
