
package framework;

import java.util.ArrayList;
import plugin.DancePluginInterface;
import plugin.PluginLoader;
import plugin.SalsaPlugin;

/**
 * This class overrides the base dance style methods to return Salsa dance moves
 * @author micaramarajh
 */
public class Salsa extends DanceStyle {

    public Salsa() {
        SalsaPlugin salsaPlugin = (SalsaPlugin) new PluginLoader().loadDancePlugin("plugin.SalsaPlugin");
        this.moves = salsaPlugin.getMoves();
    }

    @Override
    public Move getMove(int i) {
        return moves.get(i);
    }

    @Override
    public ArrayList<Move> getMoves() {
        return this.moves;
    }

    @Override
    public void addMove(Move m) {
        moves.add(m);
    }

    @Override
    public void removeMove(int i) {
        moves.remove(i);
    }

    @Override
    public String toString() {
        String str = "";
        for (Move m : moves) {
            for (Line l : m.getLines()) {
                System.out.print(l.getName() + ":" + " ");
                for (Element e : l.getLineElementArray()) {
                    System.out.print(e.getName());
                    System.out.print(" ");
                    System.out.print(e.getSymbol());
                    System.out.print(" ");
                    //System.out.println(e.getName());
                }
                System.out.println();
            }   
        }
        return "";
    }
}

    

   

   

    
    


   

    

