
package framework;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * @author micaramarajh
 * A sequence is represented as a data structure of Move objects
 */

public class Sequence {

    private ArrayList <Move> movesArrayList;

    public Sequence () {
        movesArrayList = new ArrayList<>();
    }

    public Sequence(ArrayList<Move> movesArrayList) {
        this.movesArrayList = movesArrayList;
    }

    /************************************
     *      ACCESSORS AND MUTATORS      *
     ************************************/
    
    /**
     * 
     * @param l Add each move to create a sequence
     */

    public void addMove(Move l) {
        movesArrayList.add((l));
    }

    public Move getMove(int i) {
        return movesArrayList.get(i);
    }

    public void setMove(int i, Move l) {
        movesArrayList.set(i, l);
    }

    public void removeMove(int i) {
        movesArrayList.remove(i);
    }

    public void removeMove(Move l) {
        movesArrayList.remove(l);
    }
    
    public ArrayList <Move> getMoveArrayList()
    {
        return this.movesArrayList;
    }
    
     @Override
    public String toString() {
        return "Sequence{" + "movesArrayList=" + movesArrayList + '}';
    }
}












 