package framework;

/**
 *
 * @author micara marajh Specifies a set of constraints in relation to a dance
 * sequence. This class acts as a wrapper for the rule set of the parser
 * component. The constraints manager class is a facade class provides
 * functionality that is hidden from the code Validate moves against a set of
 * constraints Facade class will direct client code to Sequence class
 */
import java.util.HashMap;

public class constraintManager<T, K> {

    public HashMap<T, K> CONSTRAINTS = new HashMap<>();

    public void addConstraint(T key, K val) {
        CONSTRAINTS.put(key, val);
    }

    public void removeConstraint(T key) {
        CONSTRAINTS.remove(key);
    }

    public void changeConstraint(T key, K val) {
        CONSTRAINTS.replace(key, val);
    }

    /**
     *
     * @param map Includes key for terms and values as expressions for grammar
     */
    public void setConstraint(HashMap<T, K> map) {
        this.CONSTRAINTS = map;
    }

    public HashMap<T, K> getConstraint() {
        return this.CONSTRAINTS;
    }

}
